//+------------------------------------------------------------------+
//|                                            TickScalper_v3.44.mq4 |
//|                             Copyright  2009-10, TrendLaboratory |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009-10, TrendLaboratory"
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#include <stdlib.mqh>

//---- input parameters
extern string     Expert_Name    = "TickScalper_v3.44";

extern int        Magic          =642342;   // Magic Number
extern int        Slippage       =     3;

extern string     Main_data      = " Trade Volume & Trade Method";
extern double     Lots           =   0.1;    // Trade Volume 
extern int        MaxOrders      =     10;    // Max Number of Orders
extern double     TakeProfit     =     0;    // Take Profit Value in pips 
extern double     ProfitTarget   =     0;    // Profit Target acc to Profit Mode 
extern double     MinProfit      =     1;    // Min Profit in pips
extern double     ProfitMode     =     0;    // 0-Pips,1-Profit,2-Total Pips,3-Total Profit
extern double     StopLoss       =     100;    // Initial Stop Value in pips
extern int        TrailingMode   =     2;    // 0-off,1-standard,2-System by Up/Dn Bands  
extern double     TrailingStop   =     0;    // Trailing Stop Value in pips
extern double     StopDeviation  =     1;    // Deviation from Up/Dn Bands in %(TrailingMode=2)
extern double     BreakEven      =     0;    // Break-Even Value in pips
extern double     PipsLock       =     0;    // Lock in pips
extern int        ExitMode       =     10;    // Exit Mode
extern double     MaxSpread      =     0;    // Max Spread in pips  
extern int        ECN_Mode       =     1;    // 1-for ECN brokers  
extern int        ReverseLogic   =     0;

extern string     Time_Inputs    = " Timing parameters ";
extern int        MainTimeFrame  =    -1;    // Time Frame in min(0-current, -1-each tick mode)
extern int        StartHour      =     6;    // Start Hour of Trade Session 
extern int        StartMinute    =     0;    // Start Minute of Trade Session 
extern int        EndHour        =    22;    // End Hour of Trade Session
extern int        EndMinute      =     0;    // End Hour of Trade Session
extern int        MonStartHour   =     8;    // Monday Start Hour of Trade Session 
extern int        MonStartMinute =     0;    // Monday Start Minute of Trade Session 
extern int        FriEndHour     =    18;    // Friday End Hour of Trade Session
extern int        FriEndMinute   =     0;    // Friday End Hour of Trade Session
extern int        NonTradeDay    =     0;    // Non Trade Day of Week
extern int        CloseTimeMode  =     0;    // CloseTime mode: 0-off,1-on
extern int        CloseHour      =    24;    // Trade Close Hour   
extern int        CloseMinute    =     0;    // Trade Close Minute   
extern int        FriCloseHour   =    20;    // Trade Close Hour in Friday   
extern int        FriCloseMinute =    55;    // Trade Close Minute in Friday 
extern double     ProcessTime    =     3;

extern string     TS_Inputs      = " TickSmoother parameters:";
extern int        TS_TimeFrame   =    -1;    // Time Frame in min(<0 - for ticks)
extern int        TS_Price       =     0;    // 0-Close;1-Open;2-High;3-Low;4-Median;5-Typical;6-Weighted Close
extern int        TS_FastMA      =     9;    // Fast MA Length(Period)
extern int        TS_SlowMA      =    20;    // Slow MA Length(Period)
extern int        TS_ConfMA1     =    55;    // Confirm MA1 Length(Period)
extern int        TS_ConfMA2     =   120;    // Confirm MA2 Length(Period)
extern int        TS_MA_Mode     =     1;    // MA Mode: 0-SMA,1-EMA,2-Wilder(SMMA),3-LWMA 
extern int        TS_NumTicks    =     0;    // TimeFrame in ticks (=0 if NumSecs  > 0)
extern int        TS_NumSecs     =    10;    // TimeFrame in secs  (=0 if NumTicks > 0) 
extern int        TS_MaxBars     =   500;    // Max Number of ticks   
extern int        TS_Shift       =     1;    // Shift relative to the current bar
extern int        TS_Mode        =     6;    // Mode: 0-off

extern string     MC_Inputs      = " MAs Confirmation parameters:";
extern int        MC_TimeFrame   =     15;    // Time Frame in min
extern int        MC_Price       =     0;    // 0-Close;1-Open;2-High;3-Low;4-Median;5-Typical;6-Weighted Close
extern int        MC_FastMA      =     9;    // Fast MA Length(Period)
extern int        MC_SlowMA      =    20;    // Slow MA Length(Period)
extern int        MC_ConfMA1     =    55;    // Confirm MA1 Length(Period)
extern int        MC_ConfMA2     =   120;    // Confirm MA2 Length(Period)
extern int        MC_MA_Mode     =     1;    // MA Mode: 0-SMA,1-EMA,2-Wilder(SMMA),3-LWMA 
extern int        MC_Shift       =     0;    // Shift relative to the current bar
extern int        MC_Mode        =     3;    // Mode: 0-off

extern string     MM_inputs      = " MoneyManagement by L.Williams ";
extern int        MM             =     1;    //  Switch
extern double     MaxRisk        =   0.03;    // Risk Factor
extern double     MaxLoss        =     0;    // Maximum Loss by 1 Lot
extern double     MaxLots        =     1;    // Max Lots
extern double     MGMode         =     1;
extern double     MGRatio        =     2;
extern double     MGStep         =    15;
extern double     MGPips         =    15;

extern string Info9                   = "News Filter Setup";
extern bool   UseTSDNewsFilter        = true;                    //Switches News Filter on/off
extern bool   High_Impact             = true;
extern int    MinsUntilNextHighNews   = 30;
extern int    MinsSincePrevHighNews   = 30;
extern bool   Medium_Impact           = false;
extern int    MinsUntilNextMediumNews = 30;
extern int    MinsSincePrevMediumNews = 30;
extern bool   Low_Impact              = false;
extern int    MinsUntilNextLowNews    = 30;
extern int    MinsSincePrevLowNews    = 30;
extern string Info10                  = "News Currency Filter";  //Select the Currency which News should be filtered
extern bool   USD                     = true;
extern bool   EUR                     = true;
extern bool   GBP                     = true;
extern bool   JPY                     = true;
extern bool   AUD                     = true;
extern bool   CAD                     = true;
extern bool   CHF                     = true;
extern bool   NZD                     = true;
extern int    TSD_CalendarID          = 4;                       //  TSD News Calendar ID reference on the TSD Homepage
extern string TSD_Calendar_URL        = "http://calendar.forex-tsd.com/calendar.php?csv=1&date=";




int      OrderBar=0;
double   Lotsi;
int      BEvent=0, TriesNum=5;
datetime CurrBar,PrevBar,LastTradeBar;
double   tClose, slowMA, fastMA, tClose1, slowMA1, fastMA1, confMA1, confMA2;
double   mClose, mslowMA, mfastMA, mClose1, mslowMA1, mfastMA1, mconfMA1, mconfMA2;
int      BEbar;
double   lot_min;
double   lot_max;
double   lot_step;
double   contract; 
double   tick_val,spread;
double   minstop;
int      NumOrders;  
double   aLots[];
datetime pTime;
double   _Point, Up, Dn;
int      cross = 0;
datetime tcross;
datetime NewsTimes[1000];
int      NewsRatings[1000];
int      NewsTotal,GMTOffset,minutesUntilNextEvent=0;
string   TSDNews=""; 

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
//---- 
   if (MainTimeFrame==0) MainTimeFrame = Period(); 
   
   CurrBar = iTime(Symbol(),MainTimeFrame,0);
   PrevBar = iTime(Symbol(),MainTimeFrame,1);
   
   lot_max = MarketInfo(Symbol(),MODE_MAXLOT);
   lot_min = MarketInfo(Symbol(),MODE_MINLOT);
   lot_step= MarketInfo(Symbol(),MODE_LOTSTEP);
   contract= MarketInfo(Symbol(),MODE_LOTSIZE);   
   tick_val= MarketInfo(Symbol(),MODE_TICKVALUE)/MathPow(10,Digits%2);
   minstop = MarketInfo(Symbol(),MODE_STOPLEVEL)*MathPow(10,Digits%2);
   _Point =  MarketInfo(Symbol(),MODE_POINT)*MathPow(10,Digits%2);
   
//----
   return(0);
}

// ---- Scan Trades
int ScanTrades(int ord,int mode)
{   
   int total = OrdersTotal();
   int numords = 0;
   bool type = false; 
   int trd = 0;
   
   for(int cnt=0; cnt<total; cnt++) 
   {        
   OrderSelect(cnt, SELECT_BY_POS);            
   if ( ord != 0 )
   {
   if ( OrderType()==0 || OrderType()==2 || OrderType()==4 ) trd =  1;
   if ( OrderType()==1 || OrderType()==3 || OrderType()==5 ) trd =  2;      
   } else trd=0;
   
   if (mode == 0) type = OrderType()<=OP_SELLSTOP;
   if (mode == 1) type = OrderType()<=OP_SELL;   
   if (mode == 2) type = OrderType()>OP_SELL && OrderType()<=OP_SELLSTOP; 
   
   if(OrderSymbol() == Symbol() && type && trd==ord && OrderMagicNumber() == Magic)  
   numords++;
   }
   return(numords);
}  

bool TimeCondition()
{
   bool result = false;
   
   datetime SessionStart = StrToTime(StartHour+":"+StartMinute);
   datetime SessionEnd   = StrToTime(EndHour+":"+EndMinute);
   if(MonStartHour>= 0 && DayOfWeek()==1) SessionStart = StrToTime(MonStartHour+":"+MonStartMinute);
   if(FriEndHour  >= 0 && DayOfWeek()==5) SessionEnd   = StrToTime(FriEndHour+":"+FriEndMinute);
      
      if(DayOfWeek()!= NonTradeDay)
      {
         if (StartHour < EndHour)
         result = TimeCurrent() >= SessionStart && TimeCurrent() < SessionEnd;      
         else
         if (StartHour > EndHour)
         result = (TimeCurrent() >= SessionStart && TimeHour(TimeCurrent()) < 24)
          ||(TimeHour(TimeCurrent()) >= 0 && TimeCurrent() < SessionEnd);
      }   
   
   return(result);
}   

double TickSmoother(int mode,int tf,int price,int fast ,int slow,int mamode,int numt,int nums,int maxb,int bar)
{
   int result = 0;
   
   
   if(TS_TimeFrame < 0)
   {  
   tClose = iCustom(NULL,0,"TickSmoother_v2.1",price,fast,slow,mamode,numt,nums,maxb,3,bar);
   fastMA = iCustom(NULL,0,"TickSmoother_v2.1",price,fast,slow,mamode,numt,nums,maxb,4,bar);
   slowMA = iCustom(NULL,0,"TickSmoother_v2.1",price,fast,slow,mamode,numt,nums,maxb,5,bar);
   
   tClose1 = iCustom(NULL,0,"TickSmoother_v2.1",price,fast,slow,mamode,numt,nums,maxb,3,bar+1);
   fastMA1 = iCustom(NULL,0,"TickSmoother_v2.1",price,fast,slow,mamode,numt,nums,maxb,4,bar+1);
   slowMA1 = iCustom(NULL,0,"TickSmoother_v2.1",price,fast,slow,mamode,numt,nums,maxb,5,bar+1);
   
      if(TS_ConfMA1 > 0 && TS_ConfMA2 > 0)
      {
      confMA1 = iCustom(NULL,0,"TickSmoother_v2.1",price,TS_ConfMA1,TS_ConfMA2,mamode,numt,nums,maxb,4,bar);
      confMA2 = iCustom(NULL,0,"TickSmoother_v2.1",price,TS_ConfMA1,TS_ConfMA2,mamode,numt,nums,maxb,5,bar);
      }
   }
   else
   {
   tClose  = iMA(NULL,tf,1,0,0,price,bar);
   fastMA  = iMA(NULL,tf,fast,0,mamode,price,bar);
   slowMA  = iMA(NULL,tf,slow,0,mamode,price,bar);
   
   tClose1 = iMA(NULL,tf,1,0,0,price,bar+1);
   fastMA1 = iMA(NULL,tf,fast,0,mamode,price,bar+1);
   slowMA1 = iMA(NULL,tf,slow,0,mamode,price,bar+1);
   
      if(TS_ConfMA1 > 0 && TS_ConfMA2 > 0)
      {
      confMA1 = iMA(NULL,tf,TS_ConfMA1,0,mamode,price,bar);
      confMA2 = iMA(NULL,tf,TS_ConfMA2,0,mamode,price,bar);
      }
   }
   
   double lim = 0.95 * iClose(NULL,0,0);
   bool ok  = tClose > lim && fastMA > lim && slowMA > lim && tClose1 > lim && fastMA1 > lim && slowMA1 > lim;
   bool ok1 = confMA1 > lim && confMA2 > lim;
     
   if(fastMA > slowMA && fastMA1 < slowMA1 && iTime(NULL,tf,0) != tcross) {cross = 1; tcross = iTime(NULL,tf,0);}
   if(fastMA < slowMA && fastMA1 > slowMA1 && iTime(NULL,tf,0) != tcross) {cross =-1; tcross = iTime(NULL,tf,0);}
   
   if(mode==1 && ok)
   {
   if (tClose > fastMA && fastMA > slowMA) result =  mode;
   if (tClose < fastMA && fastMA < slowMA) result = -mode; 
   }
   else
   if(mode==2 && ok)
   {
   if (tClose > fastMA && tClose1 < fastMA1 && fastMA > slowMA) result =  mode;
   if (tClose < fastMA && tClose1 > fastMA1 && fastMA < slowMA) result = -mode; 
   }
   else
   if(mode==3 && ok && ok1)
   {
   if (tClose > fastMA && fastMA > slowMA && slowMA > confMA1 && confMA1 > confMA2) result =  mode;
   if (tClose < fastMA && fastMA < slowMA && slowMA < confMA1 && confMA1 < confMA2) result = -mode; 
   }
   else
   if(mode==4 && ok && ok1)
   {
   if (tClose > fastMA && tClose1 < fastMA1 && fastMA > slowMA && slowMA > confMA1 && confMA1 > confMA2) result =  mode;
   if (tClose < fastMA && tClose1 > fastMA1 && fastMA < slowMA && slowMA < confMA1 && confMA1 < confMA2) result = -mode; 
   }
   else
   if(mode==5 && ok && ok1)
   {
   double up = iBands(NULL,tf,slow,1,0,price,MODE_UPPER,0);
   double dn = iBands(NULL,tf,slow,1,0,price,MODE_LOWER,0);
   if (tClose > fastMA /*&& tClose1 < fastMA1*/ && fastMA > slowMA && slowMA > confMA1 && confMA1 > confMA2 && tClose < up && cross == 1) result =  mode;
   if (tClose < fastMA /*&& tClose1 > fastMA1*/ && fastMA < slowMA && slowMA < confMA1 && confMA1 < confMA2 && tClose > dn && cross ==-1) result = -mode; 
   }
   else
   if(mode==6 && ok && ok1)
   {
   if (tClose > fastMA && fastMA > slowMA && fastMA1 < slowMA1 && slowMA > confMA1 && confMA1 > confMA2) result =  mode;
   if (tClose < fastMA && fastMA < slowMA && fastMA1 > slowMA1 && slowMA < confMA1 && confMA1 < confMA2) result = -mode; 
   }
   else
   if(mode == 7)// && ok && ok1)
   {
   if (iRSI(NULL,tf,2,0,1) < 30) result =  mode;
   if (iRSI(NULL,tf,2,0,1) > 70) result = -mode; 
   }
   else
   if(mode == 0) result = 0;
   
   return(result); 
}

double MA_Confirm(int mode,int tf,int price,int fast ,int slow,int mamode,int bar)
{
   int result = 0;
    
   mClose   = iMA(NULL,tf,1,0,0,price,bar);
   mfastMA  = iMA(NULL,tf,fast,0,mamode,price,bar);
   mslowMA  = iMA(NULL,tf,slow,0,mamode,price,bar);
   
   mClose1  = iMA(NULL,tf,1,0,0,price,bar+1);
   mfastMA1 = iMA(NULL,tf,fast,0,mamode,price,bar+1);
   mslowMA1 = iMA(NULL,tf,slow,0,mamode,price,bar+1);
   
   double lim = 0.95 * Close[0];
   bool ok  = mClose > lim && mfastMA > lim && mslowMA > lim && mClose1 > lim && mfastMA1 > lim && mslowMA1 > lim;
   
   if(MC_ConfMA1 > 0 && MC_ConfMA2 > 0)
   {
   mconfMA1 = iMA(NULL,tf,MC_ConfMA1,0,mamode,price,bar);
   mconfMA2 = iMA(NULL,tf,MC_ConfMA2,0,mamode,price,bar);
   bool ok1 = mconfMA1 > lim && mconfMA2 > lim;
   }
     
     
   if(mode==1 && ok)
   {
   if (mClose > mfastMA && mfastMA > mslowMA) result =  mode;
   if (mClose < mfastMA && mfastMA < mslowMA) result = -mode; 
   }
   else
   if(mode==2 && ok)
   {
   if (mClose > mfastMA && mClose1 < mfastMA1 && mfastMA > mslowMA) result =  mode;
   if (mClose < mfastMA && mClose1 > mfastMA1 && mfastMA < mslowMA) result = -mode; 
   }
   else
   if(mode==3 && ok && ok1)
   {
   if (mClose > mfastMA && mfastMA > mslowMA && mslowMA > mconfMA1 && mconfMA1 > mconfMA2) result =  mode;
   if (mClose < mfastMA && mfastMA < mslowMA && mslowMA < mconfMA1 && mconfMA1 < mconfMA2) result = -mode; 
   }
   else
   if(mode==4 && ok && ok1)
   {
   if (mfastMA > mslowMA && mslowMA > mconfMA1 && mconfMA1 > mconfMA2) result =  mode;
   if (mfastMA < mslowMA && mslowMA < mconfMA1 && mconfMA1 < mconfMA2) result = -mode; 
   }
   else
   if(mode==5 && ok)
   {
   if (mClose > mfastMA && mfastMA > mslowMA && mfastMA1 < mslowMA1) result =  mode;
   if (mClose < mfastMA && mfastMA < mslowMA && mfastMA1 > mslowMA1) result = -mode; 
   }
   else
   if(mode==6 && ok)
   {
   if (mClose > mfastMA && mfastMA > mslowMA && mfastMA1 < mslowMA1) result =-mode;
   if (mClose < mfastMA && mfastMA < mslowMA && mfastMA1 > mslowMA1) result = mode; 
   }
   else
   if(mode==7 && ok && ok1)
   {
   double up = iBands(NULL,tf,slow,1,0,price,MODE_UPPER,0);
   double dn = iBands(NULL,tf,slow,1,0,price,MODE_LOWER,0);
   if (mfastMA > mslowMA && mslowMA > mconfMA1 && mconfMA1 > mconfMA2 && mClose < up) result =  mode;
   if (mfastMA < mslowMA && mslowMA < mconfMA1 && mconfMA1 < mconfMA2 && mClose > dn) result = -mode; 
   }
   else
   if(mode==8 && ok && ok1)
   {
   up = iBands(NULL,tf,slow,1,0,price,MODE_UPPER,0);
   dn = iBands(NULL,tf,slow,1,0,price,MODE_LOWER,0);
   double AO  = iAO(NULL, tf, bar);
   double AO1 = iAO(NULL, tf, bar+1);
   if (mfastMA > mslowMA && mslowMA > mconfMA1 && mconfMA1 > mconfMA2 && mClose < up && AO > AO1) result =  mode;
   if (mfastMA < mslowMA && mslowMA < mconfMA1 && mconfMA1 < mconfMA2 && mClose > dn && AO < AO1) result = -mode; 
   }
   else
   if(mode == 0) result = 0;
   
   return(result); 
}


int TradeSignal()
{   
   int Signal =0;
      
   if (TS_Mode>0)
   int TS = TickSmoother(TS_Mode,TS_TimeFrame,TS_Price,TS_FastMA,TS_SlowMA,TS_MA_Mode,TS_NumTicks,TS_NumSecs,TS_MaxBars,TS_Shift); 
   else TS = 0;
   
   if (MC_Mode>0)
   int MC = MA_Confirm(MC_Mode,MC_TimeFrame,MC_Price,MC_FastMA,MC_SlowMA,MC_MA_Mode,MC_Shift); 
   else MC = 0;
   
   if (TS == TS_Mode && MC == MC_Mode) Signal = 1;
   if (TS ==-TS_Mode && MC ==-MC_Mode) Signal =-1;
   
   return(Signal);
}

bool MoneyManagement()
{
   double vol;
//--- check data
   if(lot_min<0 || lot_max<=0.0 || lot_step<=0.0) 
   {
   Print("CalculateVolume: invalid MarketInfo() results [",lot_min,",",lot_max,",",lot_step,"]");
   return(0);
   }
   if(AccountLeverage()<=0)
   {
   Print("CalculateVolume: invalid AccountLeverage() [",AccountLeverage(),"]");
   return(0);
   }
//--- basic formula
  
   if (MM == 1)
   vol=NormalizeDouble(AccountFreeMargin()*MaxRisk*AccountLeverage()/contract,2);
   else
   if (MM == 2 && MaxLoss>0)
   vol = NormalizeDouble(AccountFreeMargin()*MaxRisk/MaxLoss,2);
   else
   vol=Lots;
//--- check min, max and step
   vol=NormalizeDouble(vol/lot_step,0)*lot_step;
   if (MaxLots > 0) lot_max = MaxLots;  
   if(vol<lot_min) vol=lot_min;
   
//---
   
   if(vol <= lot_max ) 
   {
   NumOrders = 1;
   ArrayResize(aLots,NumOrders);
   aLots[NumOrders-1]=vol;
   if(vol < lot_min) aLots[NumOrders-1]=lot_min;
   }  
   else
   if(vol > lot_max)
   {
   NumOrders = 1+MathFloor(vol/lot_max); 
   if(NumOrders > MaxOrders) NumOrders = MaxOrders; 
   
   ArrayResize(aLots,NumOrders);
      double SumVol = 0;
      for (int i=0; i<NumOrders-1;i++)
      {
      aLots[i] = MathCeil(vol/lot_step/NumOrders)*lot_step;
      if(aLots[i]>lot_max) aLots[i]=lot_max; 
      SumVol += aLots[i];
      }
      aLots[NumOrders-1] = vol - SumVol; 
      if (aLots[NumOrders-1]>lot_max) aLots[NumOrders-1]=lot_max;
   }         
//---
   if (NumOrders>0) return(true);
}   


void TrailStop()
{
   int    error;  
   bool   result=false;
   double Gain = 0;
   int    total = OrdersTotal(); 
   for (int cnt=0;cnt<total;cnt++)
   { 
   OrderSelect(cnt, SELECT_BY_POS);   
   int mode=OrderType();    
      if ( OrderSymbol()==Symbol() && OrderMagicNumber()==Magic) 
      {
         if (mode==OP_BUY) 
         {
			   if (BreakEven > 0 && BEvent < total )
			   {
			   Gain = (MarketInfo(Symbol(),MODE_BID) - OrderOpenPrice())/_Point;
			      if( Gain >= BreakEven && OrderStopLoss()<=OrderOpenPrice()+PipsLock*_Point) 
			      {
			      double BuyStop = NormalizeDouble(OrderOpenPrice()+PipsLock*_Point,Digits);
			      BEvent+=1;
			      }
			   }
			   else			   
			   if (TrailingMode == 1 && TrailingStop > 0) BuyStop = NormalizeDouble(MarketInfo(Symbol(),MODE_BID) - TrailingStop*_Point,Digits);
			   else
			   if (TrailingMode == 2 && Dn > 0) BuyStop = NormalizeDouble((1.0-0.01*StopDeviation)*Dn,Digits);
			   
			   if( NormalizeDouble(OrderOpenPrice(),Digits)<= BuyStop) 
            {   
			      if ( BuyStop > NormalizeDouble(OrderStopLoss(),Digits) || OrderStopLoss() == 0) 
			      {
			         for(int k = 0 ; k < TriesNum; k++)
                  {
                  result = OrderModify(OrderTicket(),OrderOpenPrice(),
			                              BuyStop,
			                              OrderTakeProfit(),0,Lime);
                  error=GetLastError();
                     if(error==0) break;
                     else {Sleep(5000); RefreshRates(); continue;}
                  }   		 
               }            
            }
         }   
// - SELL Orders          
         if (mode==OP_SELL)
         {
            if (BreakEven > 0 && BEvent > -total)
			   {
			   Gain = (OrderOpenPrice()-MarketInfo(Symbol(),MODE_ASK))/_Point;
			   
			      if( Gain >= BreakEven && (OrderStopLoss()>=OrderOpenPrice()-PipsLock*_Point || OrderStopLoss()== 0)) 
			      {
			      double SellStop = NormalizeDouble(OrderOpenPrice()-PipsLock*_Point,Digits);
			      BEvent-=1;
			      }
			   }
			   else 
			   if (TrailingMode == 1 && TrailingStop > 0) SellStop = NormalizeDouble(MarketInfo(Symbol(),MODE_ASK) + TrailingStop*_Point,Digits);   
            else
            if (TrailingMode == 2 && Up > 0) SellStop = NormalizeDouble((1.0+0.01*StopDeviation)*Up,Digits);
                        
            if(NormalizeDouble(OrderOpenPrice(),Digits) >= SellStop && SellStop>0) 
            {
               if( SellStop < NormalizeDouble(OrderStopLoss(),Digits) || OrderStopLoss() == 0) 
               {
                  for( k = 0 ; k < TriesNum; k++)
                  {
                  result = OrderModify(OrderTicket(),OrderOpenPrice(),
			                              SellStop,
			                              OrderTakeProfit(),0,Orange);
                  error=GetLastError();
                     if(error==0) break;
                     else {Sleep(5000); RefreshRates(); continue;}
                  }
               }   
   			}	    
         }
      }
   }     
}

// ---- Open Sell Orders
void SellOrdOpen(double mult)
{		     
   double Stop,Profit;
   int ticket = 0;
   int tr = 1;
   
   int    Mode = OP_SELL;
      
   
	
	if(MoneyManagement())
	{
      for (int i=0; i<NumOrders;i++)
      {		
	   double SellPrice = Bid;
      double StopPrice = Bid;
	   
	   if (StopLoss > 0) double SellStop  = SellPrice + StopLoss*_Point; 
	   else
	   if (TrailingMode==2 && Up > 0) SellStop = NormalizeDouble((1.0+0.01*StopDeviation)*Up,Digits); 
	   else 
	   SellStop = 0;
   
      if (StopLoss > 0 && SellStop - Ask < 10*_Point) SellStop  = SellPrice + 10 *_Point;     
   
      if (MM == 2 && SellStop > 0) MaxLoss = tick_val*(SellStop-Bid)/_Point;    
      if (TakeProfit  > 0) double SellProfit = SellPrice - TakeProfit*_Point; 
      else 
      SellProfit=0;
	   
	   if(mult == 0) double lots = aLots[i];
      else
      if(mult  > 0) lots = mult*MaxLots(2);
           
	   if(ECN_Mode == 1) {Stop=0; Profit=0;}
	   else {Stop = SellStop; Profit = SellProfit;} 
	        
         while ( ticket <= 0 && tr <= TriesNum)
         {     
	      ticket = OrderSend(Symbol(),Mode,lots,
	                         NormalizeDouble(SellPrice , Digits),
	                         Slippage,
	                         NormalizeDouble(Stop  , Digits),
	                         NormalizeDouble(Profit, Digits),
	                         Expert_Name+" SELL",Magic,0,Red);
   
            if(ticket > 0) 
            {
            if (OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES)) {BEvent=0; cross = 0;} 
            if(ECN_Mode == 1 && (SellStop > 0 || SellProfit > 0)) OrderModify(ticket,OrderOpenPrice(),SellStop,SellProfit,0,Magenta);
            }
      	   else
      	   if(ticket < 0)
	         { 	
            Sleep(5000);
            RefreshRates();
            tr += 1;
            if(GetLastError()>0)      
            Print("SELL : OrderSend failed with error #",ErrorDescription(GetLastError()));
            } 	
         }    
      }
   }      
   //return(0);
}
// ---- Open Buy Orders
void BuyOrdOpen(double mult)
{		     
   double Stop,Profit;
   int ticket = 0;
   int tr = 1;
   
   int    Mode      = OP_BUY;
   
	if (MoneyManagement())
	{	  
      for (int i=0; i<NumOrders;i++)
      {	
      double BuyPrice  = Ask;
      double StopPrice = Ask;  
      
      if (StopLoss > 0) double BuyStop  = BuyPrice - StopLoss*_Point; 
      else 
	   if (TrailingMode==2 && Dn > 0) BuyStop = NormalizeDouble((1.0-0.01*StopDeviation)*Dn,Digits); 
	   else 
      BuyStop = 0;
      
      if (StopLoss > 0 && Bid - BuyStop < 10*_Point) BuyStop  = BuyPrice - 10 *_Point; 	   
      if (MM == 2 && BuyStop > 0) MaxLoss = tick_val*(Ask - BuyStop)/_Point; 
           
      if (TakeProfit  > 0) double BuyProfit= BuyPrice + TakeProfit*_Point;   
	   else 
	   BuyProfit=0;
      
      if(mult == 0) double lots = aLots[i];
      else
      if(mult  > 0) lots = mult*MaxLots(1);
            
      if(ECN_Mode == 1) {Stop=0; Profit=0;}
	   else {Stop = BuyStop; Profit = BuyProfit;}     
               
         while ( ticket <= 0 && tr <= TriesNum)
         {     
         ticket = OrderSend(Symbol(),Mode, lots,
                            NormalizeDouble(BuyPrice , Digits),
	                         Slippage,
	                         NormalizeDouble(Stop  , Digits), 
	                         NormalizeDouble(Profit, Digits),
	                         Expert_Name+" BUY",Magic,0,Blue);
      
            if(ticket > 0) 
            {
            if (OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES)) {BEvent=0; cross = 0;} 
            if(ECN_Mode == 1 && (BuyStop > 0 || BuyProfit > 0)) OrderModify(ticket,OrderOpenPrice(),BuyStop,BuyProfit,0,Aqua);
            }
	         else
	         if(ticket < 0)
	         { 	
            Sleep(5000);
            RefreshRates();
            tr += 1;
            if(GetLastError()>0)      
            Print("BUY : OrderSend failed with error #",ErrorDescription(GetLastError()));
            } 	    
         }
      }
   }      
   //return(0);
} 

void CloseOrder(int mode)  
{
   bool result=false; 
   int  total=OrdersTotal();
   
   for (int i=OrdersTotal(); i>=0; i--)  
   {
   OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if (OrderMagicNumber() == Magic && OrderSymbol() == Symbol()) 
      {
      if ((mode == 0 || mode ==1) && OrderType()==OP_BUY ) {result=CloseAtMarket(OrderTicket(),OrderLots(),Aqua); break;}
      if ((mode == 0 || mode ==2) && OrderType()==OP_SELL) {result=CloseAtMarket(OrderTicket(),OrderLots(),Pink); break;}
      }
   }
}


bool CloseAtMarket(int ticket,double lot,color clr) 
{
   bool result = false; 
   int  ntr;
      
   int tries=0;
   while (!result && tries < TriesNum) 
   {
      RefreshRates();
      result=OrderClose(ticket,lot,OrderClosePrice(),Slippage,clr);
      tries++;
   }
   if (!result) Print("Error closing order : ",ErrorDescription(GetLastError()));
   return(result);
}

double TotalProfit(int trade,int pmode,int hmode,datetime date)
{
   double Pips = 0, profit=0, totalPips = 0, totalProfits = 0, mPips = 0;   
      
      if(hmode == 0) 
      {
      int total = OrdersTotal(); 
      int opt =  MODE_TRADES;
      }
      else 
      {
      total = OrdersHistoryTotal();
      opt =  MODE_HISTORY;
      }
      
   for (int cnt=0;cnt<total;cnt++)
   { 
   OrderSelect(cnt, SELECT_BY_POS, opt);   
   
   int mode=OrderType();
   bool mcondition = false, dcondition = false;
   
   if ( Magic>0 && OrderMagicNumber()==Magic && OrderSymbol() == Symbol()) mcondition = true;
   else if ( Magic==0 ) mcondition = true;   
   
   if(date > 0)
   { 
   if(date == StrToTime(TimeToStr(OrderOpenTime(),TIME_DATE))) dcondition = true;
   }
   else
   if(date == 0) dcondition = true;  
       
      if (mcondition && dcondition)
      {      
         if (mode == OP_BUY && (trade == 1 || trade == 0))
         {
         Pips = (OrderClosePrice() - OrderOpenPrice())/_Point;
         profit = OrderProfit() + OrderSwap() + OrderCommission();
         totalPips += Pips;
         totalProfits += profit;
         if(pmode == 4 && OrderLots() == MaxLots(1)) mPips = Pips; 
         }
         
         if (mode == OP_SELL && (trade == 2 || trade == 0))   
         {          
         Pips = (OrderOpenPrice() - OrderClosePrice())/_Point;
         profit = OrderProfit() + OrderSwap() + OrderCommission();
         totalPips += Pips;
         totalProfits += profit;
         if(pmode == 4 && OrderLots() == MaxLots(2)) mPips = Pips; 
         }
      }            
	}
   if(pmode==0) return(Pips);
   else
   if(pmode==1) return(profit);
   else
   if(pmode==2) return(totalPips);
   else
   if(pmode==3) return(totalProfits);
   else
   if(pmode==4) return(mPips);
}



double MaxLots(int trade)
{
   int total = OrdersTotal();
   double maxlot = 0;  
     
   for (int cnt=0;cnt<total;cnt++)
   { 
   if(!OrderSelect(cnt, SELECT_BY_POS)) break;   
      if (OrderMagicNumber()==Magic && OrderSymbol() == Symbol()) 
      {
      if (OrderType() == OP_BUY  && (trade == 1 || trade == 0)) maxlot = MathMax(maxlot,OrderLots()); 
      if (OrderType() == OP_SELL && (trade == 2 || trade == 0)) maxlot = MathMax(maxlot,OrderLots()); 
      }
   }
   return(maxlot);
}

bool News() {
   if (UseTSDNewsFilter && !IsTesting() && !IsOptimization()) {   
       Check_News_Calendar();     
       for (int i=0; i<=NewsTotal; i++) {
         if (NewsRatings[i] == 3) {
           datetime BeforeNews = NewsTimes[i] - MinsUntilNextHighNews*60;
           datetime AfterNews  = NewsTimes[i] + MinsSincePrevHighNews*60; 
           } 
         else if (NewsRatings[i] == 2) {
           BeforeNews = NewsTimes[i] - MinsUntilNextMediumNews*60;
           AfterNews  = NewsTimes[i] + MinsSincePrevMediumNews*60; 
           } 
         else if (NewsRatings[i] == 1) {
           BeforeNews = NewsTimes[i] - MinsUntilNextLowNews*60;
           AfterNews  = NewsTimes[i] + MinsSincePrevLowNews*60;
           }        
         if ((TimeCurrent() >= BeforeNews && TimeCurrent() <= AfterNews)) {   
           if (High_Impact && NewsRatings[i] == 3) {
               TSDNews = "Avoiding High Impact News!";
             return(true);
             }
           if (Medium_Impact && NewsRatings[i] == 2) {
               TSDNews = ("Avoiding Medium Impact News!");
             return(true);
             }
           if (Low_Impact && NewsRatings[i] == 1) {
               TSDNews = "Avoiding Low Impact News!";
             return(true);
             }
           }            
         }
       TSDNews = "No News to filter!";
       return(false);           
   }
   if (!UseTSDNewsFilter) {
     TSDNews = "News Filter off!";
     return(false);
     }
   return(false);
}
string Download_ForexTSD_Calendar() {

   string result = "";   
        
   datetime StartDay    = iTime(NULL,PERIOD_D1,0);
   datetime OldStartDay = iTime(NULL,PERIOD_D1,1);
     
   string OldStartYear = TimeYear(OldStartDay);
   if (TimeMonth(OldStartDay) > 9) string OldStartMonth = TimeMonth(OldStartDay);
   else OldStartMonth = "0" + TimeMonth(OldStartDay);
   if (TimeDay(OldStartDay) > 9) string OldStart_Day = TimeDay(OldStartDay);
   else OldStart_Day = "0" + TimeDay(OldStartDay);
   
   string OldCalName = "ForexTSD_"+OldStartYear+"-"+OldStartMonth+"-"+OldStart_Day+".csv";   
   int handle = FileOpen(OldCalName,FILE_CSV|FILE_READ,';');
   if (handle > 0) { FileClose(handle); FileDelete(OldCalName); }
           
   string StartYear = TimeYear(StartDay);
   if (TimeMonth(StartDay) > 9) string StartMonth = TimeMonth(StartDay);
   else StartMonth = "0" + TimeMonth(StartDay);   
   if (TimeDay(StartDay) > 9) string Start_Day = TimeDay(StartDay);
   else Start_Day = "0" + TimeDay(StartDay);   
   
   string StartTime = StartYear + StartMonth + Start_Day;      
   string NewsWebAdress = TSD_Calendar_URL+StartTime+"&calendar[]="+TSD_CalendarID;
   string CalName = "ForexTSD_"+StartYear+"-"+StartMonth+"-"+Start_Day+".csv";     
   
   handle = FileOpen(CalName,FILE_CSV|FILE_READ,';');
   if (handle < 0) {
     GrabWeb(NewsWebAdress, result);      
     if (result != "") {         
       handle = FileOpen(CalName,FILE_CSV|FILE_WRITE,';');         
       if (handle > 0) {
         FileWrite(handle, result);
         FileClose(handle);
       }
     } else CalName = "";     
   } else FileClose(handle);
   return(CalName);   
}
//***********************************************************************************************
void Read_ForexTSD_Calendar(string fName) {

   string sDate[1000];          // Date   
   string sRating[1000];        // Rating
   string sActual[1000];        // Actual value
   string sForecast[1000];      // Forecast value
   string sPrevious[1000];      // Previous value
   string sTime[1000];          // Time
   string sDescription[1000];   // Description
   string sCurrency[1000];      // Currency affected     
             
   int handle = FileOpen(fName,FILE_CSV|FILE_READ,';');
   if (handle < 1) {
    
     return(false);
   }   
     int i=0;
     while (!FileIsEnding(handle))
     {
     sDate[i]        = FileReadString(handle);          
     sTime[i]        = FileReadString(handle);         
     sCurrency[i]    = FileReadString(handle);      
     sDescription[i] = FileReadString(handle);   
     sRating[i]      = FileReadString(handle);        
     sActual[i]      = FileReadString(handle);       
     sForecast[i]    = FileReadString(handle);      
     sPrevious[i]    = FileReadString(handle);                
   
     if ((sCurrency[i] == "USD") && (!USD)) continue;            
     if ((sCurrency[i] == "EUR") && (!EUR)) continue;            
     if ((sCurrency[i] == "GBP") && (!GBP)) continue;                      
     if ((sCurrency[i] == "JPY") && (!JPY)) continue;
     if ((sCurrency[i] == "AUD") && (!AUD)) continue;
     if ((sCurrency[i] == "CAD") && (!CAD)) continue;                     
     if ((sCurrency[i] == "CHF") && (!CHF)) continue;  
     if ((sCurrency[i] == "NZD") && (!NZD)) continue;   
     
     datetime News_Time = StrToTime(sDate[i]+" "+sTime[i])+GMTOffset*3600;      
     sTime[i] = StringSubstr(TimeToStr(News_Time), 11, 5);
     NewsTimes[i] = News_Time;
     NewsRatings[i] = StrToInteger(sRating[i]);
     
     i++;
   }
   NewsTotal = i;   
   return(0);
}
//********************************************************************************************
void Check_News_Calendar() {

   datetime cTime = iTime(NULL,PERIOD_D1,0);
   static datetime prevTime;
   
   if ((TimeCurrent() > cTime && cTime > prevTime)) {               
     string cName = Download_ForexTSD_Calendar();  
     if (cName != "") {   
       Read_ForexTSD_Calendar(cName);       
       prevTime = cTime;
     }       
   }  
   return(0);
}
bool bWinInetDebug = false;

int hSession_IEType;
int hSession_Direct;
int Internet_Open_Type_Preconfig = 0;
int Internet_Open_Type_Direct = 1;
int Internet_Open_Type_Proxy = 3;
int Buffer_LEN = 80;

#import "wininet.dll"
#define INTERNET_FLAG_PRAGMA_NOCACHE    0x00000100
#define INTERNET_FLAG_NO_CACHE_WRITE    0x04000000 
#define INTERNET_FLAG_RELOAD            0x80000000 

int InternetOpenA(string sAgent,	int lAccessType, string	sProxyName="",	string sProxyBypass="",	int lFlags=0);
int InternetOpenUrlA(int hInternetSession, string sUrl, string	sHeaders="", int lHeadersLength=0, int	lFlags=0, int lContext=0);
int InternetReadFile(int hFile, string	sBuffer, int lNumBytesToRead,	int& lNumberOfBytesRead[]);
int InternetCloseHandle(int hInet);
#import
//*************************************************************************************************
int hSession(bool Direct)
{
	string InternetAgent;
	if (hSession_IEType == 0) {
		InternetAgent = "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; Q312461)";
		hSession_IEType = InternetOpenA(InternetAgent, Internet_Open_Type_Preconfig, "0", "0", 0);
		hSession_Direct = InternetOpenA(InternetAgent, Internet_Open_Type_Direct, "0", "0", 0);
	}
	if (Direct) { 
		return(hSession_Direct); 
	} else {
		return(hSession_IEType); 
	}
}
//**************************************************************************************************
bool GrabWeb(string strUrl, string& strWebPage) {

	int hInternet;
	int iResult;
	int lReturn[]	= {1};
	string sBuffer	= "                                                                                                                                                                                                                                                           ";	// 255 spaces
	int bytes;
	
	hInternet = InternetOpenUrlA(hSession(FALSE), strUrl, "0", 0,INTERNET_FLAG_NO_CACHE_WRITE | 
	                             INTERNET_FLAG_PRAGMA_NOCACHE | INTERNET_FLAG_RELOAD, 0);
								
	if (hInternet == 0) return(false);
	
	iResult = InternetReadFile(hInternet, sBuffer, Buffer_LEN, lReturn);
	
	if (iResult == 0) return(false);
	bytes = lReturn[0];

	strWebPage = StringSubstr(sBuffer, 0, lReturn[0]);
	
	while (lReturn[0] != 0)	{
		iResult = InternetReadFile(hInternet, sBuffer, Buffer_LEN, lReturn);
		if (lReturn[0]==0) break;
		bytes = bytes + lReturn[0];
		strWebPage = strWebPage + StringSubstr(sBuffer, 0, lReturn[0]);
	}

	iResult = InternetCloseHandle(hInternet);
	if (iResult == 0) return(false);
	return(true);
}
bool NewsTime() {
   bool News=false;
      static int PrevMinute = -1;
         PrevMinute = Minute();
               News = true; 
   return(News);
}

void ChartComment()
{
   string sComment   = "";
   string sp         = "----------------------------------------\n";
   string NL         = "\n";
   double pips = TotalProfit(0,2,0,0);
   double usd  = TotalProfit(0,3,0,0);
   double hist = TotalProfit(0,3,1,StrToTime(TimeToStr(TimeCurrent(),TIME_DATE)));
   double sum  = hist + usd;     
   
   sComment = sp;
   sComment = sComment+"Expert Name : "+Expert_Name+NL;
   sComment = sComment+"Time: Current= "+TimeToStr(TimeCurrent()) + NL;
   sComment = sComment+"TSD News: "+TSDNews + NL;
   sComment = sComment+"Orders: Open= "+ScanTrades(0,1)+" Pending= "+ScanTrades(0,2)+" All= "+ScanTrades(0,0)+NL;
   sComment = sComment+"Current Profit(pips)= " + DoubleToStr(pips,1) + NL;
   sComment = sComment+"Current Profit(USD) = " + DoubleToStr(usd,2)  + NL;
   sComment = sComment+"Daily Profit(USD): Closed= " + DoubleToStr(hist,2) + " Open= " + DoubleToStr(usd,2) + " Summary = " + DoubleToStr(sum,2) + NL; 
   
   sComment = sComment+sp;
   sComment = sComment + "Fast0=" + DoubleToStr(fastMA,Digits) + " Slow0=" + DoubleToStr(slowMA,Digits) + " Close0=" + DoubleToStr(tClose,Digits)+NL; 
   sComment = sComment + "Fast1=" + DoubleToStr(fastMA1,Digits) + " Slow1=" + DoubleToStr(slowMA1,Digits) + " Close1=" + DoubleToStr(tClose1,Digits)+NL; 
   if(TS_ConfMA1 > 0 && TS_ConfMA2 > 0)
   sComment = sComment + "Conf1=" + DoubleToStr(confMA1,Digits) + " Conf2=" + DoubleToStr(confMA2,Digits) + NL; 
   
   Comment(sComment);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
   if(iBars(Symbol(),MainTimeFrame) < 100 || !IsTradeAllowed()) return(0); 
   
   News();
   NewsTime();
   
   if(MainTimeFrame >= 0) 
   CurrBar = iTime(Symbol(),MainTimeFrame,0);
   else 
   {
   CurrBar = iTime(Symbol(),0,0);
   PrevBar = iTime(Symbol(),0,1);  
   }
   
   datetime TimeClose = StrToTime(CloseHour+":"+CloseMinute); 
   if(FriCloseHour >= 0 && DayOfWeek() == 5 && FriCloseHour > StartHour) TimeClose = StrToTime(FriCloseHour+":"+FriCloseMinute); 
   
   spread = NormalizeDouble((Ask - Bid)/_Point,1);
   ChartComment();
   
   if (CurrBar != PrevBar)
   {
      int b_trades = ScanTrades(1,0);
      int s_trades = ScanTrades(2,0);
      int trades = b_trades + s_trades;
   
      if(TS_Mode != 0 || MC_Mode != 0) int Signal = TradeSignal();
   }   
      if(trades == 0 && !TimeCondition()) return(0); 
        
      if(trades > 0)
      {
         if(ExitMode == 1)
         {
         if (s_trades > 0 && fastMA > slowMA && slowMA > 0) {Print("Sell Close 1"); while(ScanTrades(2,0)>0) CloseOrder(2);}
         if (b_trades > 0 && fastMA < slowMA && slowMA > 0) {Print("Buy Close 1") ; while(ScanTrades(1,0)>0) CloseOrder(1);}
         }
         else
         if(ExitMode == 2)
         {
         if (s_trades > 0 && tClose1 < fastMA1 && tClose > fastMA && fastMA > 0 && fastMA1 > 0) {Print("Sell Close 2"); while(ScanTrades(2,0)>0) CloseOrder(2);}
         if (b_trades > 0 && tClose1 > fastMA1 && tClose < fastMA ) {Print("Buy Close 2") ; while(ScanTrades(1,0)>0) CloseOrder(1);}
         } 
         else
         if(ExitMode == 3)
         {
         double gain = TotalProfit(0,1,0,0); 
         if (s_trades > 0 && ((tClose1 < fastMA1 && tClose > fastMA && fastMA > 0 && fastMA1 > 0 && gain > 0) || tClose >= confMA1)) {Print("Sell Close 3"); while(ScanTrades(2,0)>0) CloseOrder(2);}
         if (b_trades > 0 && ((tClose1 > fastMA1 && tClose < fastMA && gain > 0) || tClose <= confMA1)) {Print("Buy Close 3") ; while(ScanTrades(1,0)>0) CloseOrder(1);}
         }     
         else
         if(ExitMode == 4)
         {
         double b_gain = TotalProfit(1,1,0,0); 
         double s_gain = TotalProfit(2,1,0,0); 
         if (s_trades > 0 && ((tClose > fastMA && fastMA > 0 && s_gain > 0) || tClose >= confMA2)) {Print("Sell Close 4"); while(ScanTrades(2,0)>0) CloseOrder(2);}
         if (b_trades > 0 && ((tClose < fastMA && b_gain > 0) || tClose <= confMA2)) {Print("Buy Close 4") ; while(ScanTrades(1,0)>0) CloseOrder(1);}
         }
         else    
         if(ExitMode == 5)
         {
         b_gain = TotalProfit(1,1,0,0); 
         s_gain = TotalProfit(2,1,0,0); 
         if (s_trades > 0 && ((tClose > fastMA && fastMA > 0 && s_gain > 0) || tClose >= mconfMA2)) {Print("Sell Close 5"); while(ScanTrades(2,0)>0) CloseOrder(2);}
         if (b_trades > 0 && ((tClose < fastMA && b_gain > 0) || tClose <= mconfMA2)) {Print("Buy Close 5") ; while(ScanTrades(1,0)>0) CloseOrder(1);}
         }    
         else    
         if(ExitMode == 6)
         {
         b_gain = TotalProfit(1,1,0,0); 
         s_gain = TotalProfit(2,1,0,0); 
         if (s_trades > 0 && ((mClose > mfastMA && mfastMA > 0 && s_gain > 0) || mClose >= mconfMA2)) {Print("Sell Close 6"); while(ScanTrades(2,0)>0) CloseOrder(2);}
         if (b_trades > 0 && ((mClose < mfastMA && b_gain > 0) || mClose <= mconfMA2)) {Print("Buy Close 6") ; while(ScanTrades(1,0)>0) CloseOrder(1);}
         }    
         else    
         if(ExitMode == 7)
         {
         b_gain = TotalProfit(1,1,0,0); 
         s_gain = TotalProfit(2,1,0,0); 
         if (s_trades > 0 && (mClose > mfastMA && mfastMA > 0 && s_gain > 0)) {Print("Sell Close 7"); while(ScanTrades(2,0)>0) CloseOrder(2);}
         if (b_trades > 0 && (mClose < mfastMA && b_gain > 0)) {Print("Buy Close 7") ; while(ScanTrades(1,0)>0) CloseOrder(1);}
         }
         else    
         if(ExitMode == 8)
         {
         b_gain = TotalProfit(1,1,0,0); 
         s_gain = TotalProfit(2,1,0,0); 
         if (s_trades > 0 && (mfastMA > mfastMA1 && mfastMA1 > 0 && s_gain > 0)) {Print("Sell Close 8"); while(ScanTrades(2,0)>0) CloseOrder(2);}
         if (b_trades > 0 && (mfastMA < mfastMA1 && b_gain > 0)) {Print("Buy Close 8") ; while(ScanTrades(1,0)>0) CloseOrder(1);}
         }      
         else    
         if(ExitMode == 9)
         {
         b_gain = TotalProfit(1,1,0,0); 
         s_gain = TotalProfit(2,1,0,0); 
         double up = iBands(NULL,MC_TimeFrame,MC_SlowMA,2,0,TS_Price,MODE_UPPER,0);
         double dn = iBands(NULL,MC_TimeFrame,MC_SlowMA,2,0,TS_Price,MODE_LOWER,0);
         if (s_trades > 0 && ((((tClose > fastMA && fastMA > 0)|| tClose < dn) && s_gain > 0) /*|| tClose >= mconfMA2*/)) {Print("Sell Close 9"); while(ScanTrades(2,0)>0) CloseOrder(2);}
         if (b_trades > 0 && ((((tClose < fastMA) || tClose > up) && b_gain > 0) /*|| tClose <= mconfMA2*/)) {Print("Buy Close 9") ; while(ScanTrades(1,0)>0) CloseOrder(1);}
         }    
         else    
         if(ExitMode == 10)
         {
         b_gain = TotalProfit(1,0,0,0); 
         s_gain = TotalProfit(2,0,0,0); 
         double t_up = iBands(NULL,TS_TimeFrame,TS_SlowMA,2,0,TS_Price,MODE_UPPER,1);
         double t_dn = iBands(NULL,TS_TimeFrame,TS_SlowMA,2,0,TS_Price,MODE_LOWER,1);
         up = iBands(NULL,MC_TimeFrame,MC_SlowMA,2,0,MC_Price,MODE_UPPER,0);
         dn = iBands(NULL,MC_TimeFrame,MC_SlowMA,2,0,MC_Price,MODE_LOWER,0);
         //if(TimeCurrent() > StrToTime("2009.09.29 17:20") && TimeCurrent() < StrToTime("2009.09.29 17:26"))
         //Print("lo=",iLow(NULL,TS_TimeFrame,0 )," dn=",t_dn," g=", s_gain);
         if (s_trades > 0 && ((fastMA > slowMA ||  iLow(NULL,MC_TimeFrame,0) <= dn ||  iLow(NULL,TS_TimeFrame,1) <= t_dn) && s_gain >= MinProfit)) {Print("Sell Close 10"); /*while(ScanTrades(2,0)>0)*/ CloseOrder(2);}
         if (b_trades > 0 && ((fastMA < slowMA || iHigh(NULL,MC_TimeFrame,0) >= up || iHigh(NULL,TS_TimeFrame,1) >= t_up) && b_gain >= MinProfit)) {Print("Buy Close 10") ; /*while(ScanTrades(1,0)>0)*/ CloseOrder(1);}
         }    
         else
         if(ExitMode == 11)
         {
         //if(TimeCurrent() > StrToTime("2010.01.12 00:00") && TimeCurrent() < StrToTime("2010.01.13 00:00")) Print(" trd=",trades," pips=",pips," ST=",ScanTrades(0,0));
         if (trades > 0 && TotalProfit(0,0,0,0) >= MGPips) while(ScanTrades(0,0)>0) CloseOrder(0);
         //if (b_trades > 1 && b_pips > MGPips) while(ScanTrades(1,0)>0) CloseOrder(1);
         }
         else
         if(ExitMode == 12)
         {
         if (trades > 0 &&  TotalProfit(0,ProfitMode,0,0) > ProfitTarget) while(ScanTrades(0,0)>0) CloseOrder(0);
         }
      
      
      
      if (CloseTimeMode > 0 && TimeCurrent() >= TimeClose && TimeCurrent() < TimeClose+ProcessTime*60) while(ScanTrades(0,0)>0) CloseOrder(0); 
      }
            
      if(MaxSpread > 0) bool spreadOK = spread <= MaxSpread; else spreadOK = true;
      
      trades = ScanTrades(0,0);   
      
      if(trades < MaxOrders)
      {
         if (TimeCondition() && spreadOK && Time[0] != pTime && Signal != 0)
         {
            if((Signal > 0 && MGMode==0) || (Signal > 0 && MGMode > 0 && trades < 1)) 
            {
            if(ReverseLogic > 0) SellOrdOpen(0);
            else BuyOrdOpen(0);
            } 
         
            if((Signal < 0 && MGMode==0) || (Signal < 0 && MGMode > 0 && trades < 1)) 
            {
            if(ReverseLogic > 0) BuyOrdOpen(0);
            else SellOrdOpen(0);
            } 
            
         pTime = Time[0];
         }   
      
         if (MGMode > 0 && trades > 0)
         {
         //if(AccountFreeMargin() <= AccountBalance()*0.5) Print("freeMargin=",AccountFreeMargin()," Balance=",AccountBalance());    
         double b_pips = TotalProfit(1,0,0,0);  
         double s_pips = TotalProfit(2,0,0,0);   
            if(AccountFreeMargin() > AccountBalance()*0.5)
            {
            if(b_pips <= -(MGStep/* + spread*/)) BuyOrdOpen(MGRatio);
            if(s_pips <= -(MGStep/* + spread*/)) SellOrdOpen(MGRatio);
            }
         }   
      }
   //}
  
   if(trades > 0)
   {
   if(ProfitTarget > 0 && TotalProfit(0,ProfitMode,0,0) >= ProfitTarget) while(ScanTrades(0,0)>0) CloseOrder(0); 
   if(BreakEven > 0 || TrailingMode>0) TrailStop();
   }
      
   PrevBar = CurrBar;
   
//----
   return(0);
} //start()
//+------------------------------------------------------------------+

